Bug 1204863 - lldb breaks readline module for Python (thereby breaking pdb, ipython, etc.)
Summary: lldb breaks readline module for Python (thereby breaking pdb, ipython, etc.)
Keywords:
Status: CLOSED EOL
Alias: None
Product: Fedora
Classification: Fedora
Component: llvm
Version: 21
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Adam Jackson
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2015-03-23 16:16 UTC by Michael Droettboom
Modified: 2015-12-02 17:44 UTC (History)
6 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2015-12-02 10:25:45 UTC
Type: Bug


Attachments (Terms of Use)

Description Michael Droettboom 2015-03-23 16:16:38 UTC
Description of problem:

lldb package includes a broken readline module for Python.  This, among other things, breaks pdb.

Version-Release number of selected component (if applicable):

3.5.0-6.fc21

How reproducible:

Always

Steps to Reproduce:
1. Install lldb package

Actual results:

$ python
>>> import readline
>>> readline.__file__
'/usr/lib64/python2.7/site-packages/readline.so'
>>> dir(readline)
['__doc__', '__file__', '__name__', '__package__']
# There's nothing here

$ python -m pdb script.py
Traceback (most recent call last):
  File "/usr/lib64/python2.7/pdb.py", line 1314, in main
    pdb._runscript(mainpyfile)
  File "/usr/lib64/python2.7/pdb.py", line 1233, in _runscript
    self.run(statement)
  File "/usr/lib64/python2.7/bdb.py", line 400, in run
    exec cmd in globals, locals
  File "<string>", line 1, in <module>
  File "setup.py", line 4, in <module>
    import glob
  File "setup.py", line 4, in <module>
    import glob
  File "/usr/lib64/python2.7/bdb.py", line 49, in trace_dispatch
    return self.dispatch_line(frame)
  File "/usr/lib64/python2.7/bdb.py", line 67, in dispatch_line
    self.user_line(frame)
  File "/usr/lib64/python2.7/pdb.py", line 158, in user_line
    self.interaction(frame, None)
  File "/usr/lib64/python2.7/pdb.py", line 210, in interaction
    self.cmdloop()
  File "/usr/lib64/python2.7/cmd.py", line 113, in cmdloop
    self.old_completer = readline.get_completer()
AttributeError: 'module' object has no attribute 'get_completer'
Uncaught exception. Entering post mortem debugging
Running 'cont' or 'step' will restart the program

Expected results:

$ python
>>> import readline
>>> readline.__file__
'/home/mdboom/python/lib64/python2.7/lib-dynload/readline.so'
>>> dir(readline)
['__doc__', '__file__', '__name__', '__package__', 'add_history', 'clear_history', 'get_begidx', 'get_completer', 'get_completer_delims', 'get_completion_type', 'get_current_history_length', 'get_endidx', 'get_history_item', 'get_history_length', 'get_line_buffer', 'insert_text', 'parse_and_bind', 'read_history_file', 'read_init_file', 'redisplay', 'remove_history_item', 'replace_history_item', 'set_completer', 'set_completer_delims', 'set_completion_display_matches_hook', 'set_history_length', 'set_pre_input_hook', 'set_startup_hook', 'write_history_file']

$ python -m pdb script.py
(Pdb)

Comment 1 Jens Petersen 2015-10-19 04:16:09 UTC
First I thought maybe this was related to '/usr/lib64/llvm/readline.so',
I see lldb has '/usr/lib64/python2.7/site-packages/readline.so'.

BTW lldb-3.6.0 and later (ie F23+) no longer include that so module.
This problem probably also happens with F22?

Comment 2 Fedora End Of Life 2015-11-04 10:05:55 UTC
This message is a reminder that Fedora 21 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 21. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as EOL if it remains open with a Fedora  'version'
of '21'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 21 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

Comment 3 Fedora End Of Life 2015-12-02 10:25:49 UTC
Fedora 21 changed to end-of-life (EOL) status on 2015-12-01. Fedora 21 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.


Note You need to log in before you can comment on or make changes to this bug.